Codeforces Round # 567 (Div. 2) B. Split a Number (string, greedy)

B. Split a Number
time limit per test2 seconds
memory limit per test512 megabytes
inputstandard input
outputstandard output
Dima worked all day and wrote down on a long paper strip his favorite number n consisting of l digits. Unfortunately, the strip turned out to be so long that it didn't fit in the Dima's bookshelf.

To solve the issue, Dima decided to split the strip into two non-empty parts so that each of them contains a positive integer without leading zeros. After that he will compute the sum of the two integers and write it down on a new strip.

Dima wants the resulting integer to be as small as possible, because it increases the chances that the sum will fit it in the bookshelf. Help Dima decide what is the minimum sum he can obtain.

Input
The first line contains a single integer l (2≤l≤100000) — the length of the Dima's favorite number.

The second line contains the positive integer n initially written on the strip: the Dima's favorite number.

The integer n consists of exactly l digits and it does not contain leading zeros. Dima guarantees, that there is at least one valid way to split the strip.

Output
Print a single integer — the smallest number Dima can obtain.

Examples
inputCopy
7
1234567
outputCopy
1801
inputCopy
3
101
outputCopy
11
Note
In the first example Dima can split the number 1234567 into integers 1234 and 567. Their sum is 1801.

In the second example Dima can split the number 101 into integers 10 and 1. Their sum is 11. Note that it is impossible to split the strip into "1" and "01" since the numbers can't start with zeros.

Question is intended:
to give you a string representation of an integer, so you integer into two branches, the two non-empty portion, and can not have a portion with a leading zero, for example into a, b, the two parts, and then seek what separate ways to make a + b minimum output value of a + b.
Ideas:
First, we deal with all the not zero digit position, added to a vector, and then we most vector binary search distance len / 2 nearest location (because the most by the middle points, the answer is optimal) to get, and then enumerate half several attachment position location, seeking a + b is the minimum value. Output can be.

See details Code:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <vector>
#include <bits/stdc++.h>
#include <iomanip>
#define ALL(x) (x).begin(), (x).end()
#define rt return
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rep(i,x,n) for(int i=x;i<n;i++)
#define repd(i,x,n) for(int i=x;i<=n;i++)
#define pii pair<int,int>
#define pll pair<long long ,long long>
#define gbtb ios::sync_with_stdio(false),cin.tie(0),cout.tie(0)
#define MS0(X) memset((X), 0, sizeof((X)))
#define MSC0(X) memset((X), '\0', sizeof((X)))
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define eps 1e-6
#define gg(x) getInt(&x)
#define db(x) cout<<"== [ "<<x<<" ] =="<<endl;
using namespace std;
typedef long long ll;
ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
ll lcm(ll a,ll b){return a/gcd(a,b)*b;}
ll powmod(ll a,ll b,ll MOD){ll ans=1;while(b){if(b%2)ans=ans*a%MOD;a=a*a%MOD;b/=2;}return ans;}
inline void getInt(int* p);
const int maxn=1000010;
const int inf=0x3f3f3f3f;
/*** TEMPLATE CODE * * STARTS HERE ***/
string S(ll n){stringstream ss;string s;ss<<n;ss>>s;return s;}
ll N(string s){stringstream ss;ll n;ss<<s;ss>>n;return n;}
string rm0(string s){//  去除前导0函数
    int i;
    for(i=0;i<s.size()-1;i++)
        if(s[i]!='0')
            break;
    return s.substr(i);
}
string ADD(string s,string t) {// 字符串整数相加,返回一个字符串
  if(s.size()<t.size())swap(s,t);s='0'+s;
  reverse(t.begin(), t.end());while(s.size()>t.size())t+='0';reverse(t.begin(), t.end());int c=0;
  for(int i=s.size();i>=0;i--)
  {
    if(c){
        if(s[i]=='9'){
            s[i]='0';c=1;
        }else{
            s[i]=(char)(s[i]+1);c=0;
        }
    }
    int sum=(int)s[i]+(int)t[i]-'0'*2;
    if(sum>=10){
        s[i]=(char)(sum-10+'0');c=1;
    }
    else 
        s[i]=(char)(sum+'0');
  }
  return rm0(s);
}
bool cmp(string s,string t) { 
    // s>=t 返回1
    // s<t 返回0
    if(s.size()!=t.size())
        return s.size()>t.size();
    for(int i=0;i<s.size();i++)
        if(s[i]!=t[i])
            return s[i]>t[i];
  return 1;
}
int main()
{
    //freopen("D:\\code\\text\\input.txt","r",stdin);
    //freopen("D:\\code\\text\\output.txt","w",stdout);
    
    int len;
    string str;
    cin>>len>>str;
    std::vector<int> v;
    v.clear();
    rep(i,0,len)
    {
        if(str[i]!='0')
        {
            v.pb(i);
        }
    }
    int k=lower_bound(ALL(v),len/2)-v.begin();
    string ans=str;
    repd(j,-2,3)
    {
        int id=max(1,min(sz(v)-1,k+j));
        string s1=str.substr(0,v[id]);
        string s2=str.substr(v[id]);
        string w=ADD(s1,s2);
        if(cmp(ans,w))
        {
            ans=w;
        }
    }
    cout<<ans<<endl;
    return 0;
}

inline void getInt(int* p) {
    char ch;
    do {
        ch = getchar();
    } while (ch == ' ' || ch == '\n');
    if (ch == '-') {
        *p = -(getchar() - '0');
        while ((ch = getchar()) >= '0' && ch <= '9') {
            *p = *p * 10 - ch + '0';
        }
    }
    else {
        *p = ch - '0';
        while ((ch = getchar()) >= '0' && ch <= '9') {
            *p = *p * 10 + ch - '0';
        }
    }
}

Guess you like

Origin www.cnblogs.com/qieqiemin/p/11033007.html
Recommended